import os

import nbconvert
import ipyrmd

script = nbconvert.ScriptExporter()
html = nbconvert.HTMLExporter()

path = '/Users/mnelimar/teaching/codingsocialscience/online-materials/exercise-answers/'


def convert(filename, converter, extension):
    src = converter.from_filename(filename=filename)
    tmp = open(filename.replace('ipynb', extension), 'w')
    tmp.write(src[0])
    tmp.close()

## python


codes = os.listdir(path)
codes = filter(lambda x: x.endswith('Python.ipynb'), codes)

for code in codes:

    filename = path + code
    convert(filename, script, 'py')
    convert(filename, html, 'html')

codes = os.listdir(path)
codes = filter(lambda x: x.endswith('R.ipynb'), codes)

for code in codes:

    filename = path + code
    convert(filename, script, 'r')
    convert(filename, html, 'html')
    ipyrmd.ipynb_to_rmd(filename, filename.replace('ipynb', 'Rmd'))
