#!/usr/bin/env python
# coding: utf-8

# In[1]:


## 5.1

ages = [25, 35, 45]

for age in ages:
    print( age )


# In[2]:


## 5.4

list_of_numbers = [5, 10, 50, 200]

for item in list_of_numbers:
    times_two = item * 2
    print( times_two )


# In[3]:


## 5.5

for number in range(0, 11):
    print( 7 * number )


# In[4]:


## 5.6

list_of_numbers = [25, 35, 45]
sum_gatherer = 0

for number in list_of_numbers:
    sum_gatherer = sum_gatherer + number
    
print( sum_gatherer )


# In[5]:


## 5.7

list_of_numbers = [25, 35, 45]
sum_gatherer = 0
n = 0

for number in list_of_numbers:
    sum_gatherer = sum_gatherer + number
    n = n + 1
    
print( sum_gatherer / n)


# In[6]:


## 5.8

ages = {
    'person1': 25,
    'person2': 35,
    'person3': 45
}

for name, age in ages.items():
    print( name, age )


# In[7]:


## 5.10

english_to_finnish = {}
english_to_finnish['i'] = 'minä'
english_to_finnish['you'] = 'sinä'
english_to_finnish['social'] = 'sosiaalinen'
english_to_finnish['science'] = 'tiede'
english_to_finnish['needs'] = 'tarvitsee'
english_to_finnish['programming'] = 'ohjelmointi'
english_to_finnish['skills'] = 'taidot'

sentence_to_translate = 'social science needs programming skills'
translated_sentence = ''

for word in sentence_to_translate.split(' '):
    translated_word = english_to_finnish[ word ]
    translated_sentence = translated_sentence + ' ' + translated_word
    
print( sentence_to_translate, 'in Finnish is', translated_sentence )


# In[8]:


## 5.11

english_to_finnish = {}
english_to_finnish['i'] = 'minä'
english_to_finnish['you'] = 'sinä'
english_to_finnish['social'] = 'sosiaalinen'
english_to_finnish['science'] = 'tiede'
english_to_finnish['needs'] = 'tarvitsee'
english_to_finnish['programming'] = 'ohjelmointi'
english_to_finnish['skills'] = 'taidot'

sentence_to_translate = 'i love you'
translated_sentence = ''

for word in sentence_to_translate.split(' '):
    if word in english_to_finnish:
        translated_word = english_to_finnish[ word ]
        translated_sentence = translated_sentence + ' ' + translated_word
    else:
        translated_sentence = translated_sentence + ' ' + "[unknown]"
    
print( sentence_to_translate, 'in Finnish is', translated_sentence )


# In[9]:


## 5.12

degree = {}


for line in open('network.txt'):
    line = line.strip()
    line = line.split('-')
    
    node1 = line[0]
    node2 = line[1]
    
    if node1 not in degree:
        degree[ node1 ] = 0
        
    if node2 not in degree:
        degree[ node2 ] = 0
    
    degree[ node1 ] = degree[ node1 ] + 1
    degree[ node2 ] = degree[ node2 ] + 1

print( degree )


# In[10]:


## 5.13

occurances = {} ## this is the mega gatherer

for number in open('numbers.txt'):
    
    number = number.strip()
    
    if number not in occurances:
         occurances[ number ] = 0
    
    occurances[ number ] = occurances[ number ] + 1
    
print( occurances )


# In[11]:


## 5.14

connections = {}

for line in open('pairs.txt'):
    line = line.strip()
    line = line.split(',')
    
    node1 = line[0]
    node2 = line[1]
    
    if node1 not in connections:
        connections[ node1 ] = [] ## i.e., en empty list
    connections[ node1 ].append( node2 )

    if node2 not in connections:
        connections[ node2 ] = [] ## i.e., en empty list
    connections[ node2 ].append( node1 )
    
print( connections )


# In[12]:


## 5.19

all_votes = [] ## collect all votes into a list

for line in open ("elections.txt"):
    line = line.split(",")
    name = line[0]
    party = line[1]
    votes = float( line[2] )
    birth_year = float( line [3] )
    
    all_votes.append( votes )
    
print( "Number of candidates", len( all_votes ) ) 

## compute mean
sum_gatherer = 0

for number in all_votes:
    sum_gatherer = sum_gatherer + number
    
print( sum_gatherer / len( all_votes) )


# In[13]:


## 5.20

votes_per_party = {}

for line in open ("elections.txt"):
    line = line.split(",")
    name = line[0]
    party = line[1]
    votes = float( line[2] )
    birth_year = float( line [3] )
    
    if party not in votes_per_party:
        votes_per_party[ party ] = 0
        
    votes_per_party[ party ] = votes_per_party[ party ] + votes

print( votes_per_party )


# In[14]:


## 5.21

candidates_per_party = {}

for line in open ("elections.txt"):
    line = line.split(",")
    name = line[0]
    party = line[1]
    votes = float( line[2] )
    birth_year = float( line [3] )
    
    if party not in candidates_per_party:
        candidates_per_party[ party ] = 0
        
    candidates_per_party[ party ] = candidates_per_party[ party ] + 1

print( candidates_per_party )


# In[15]:


## 5.22

votes_per_party = {}

for line in open ("elections.txt"):
    line = line.split(",")
    name = line[0]
    party = line[1]
    votes = float( line[2] )
    birth_year = float( line [3] )
    
    if party not in votes_per_party:
        votes_per_party[ party ] = []
        
    votes_per_party[ party ].append( votes )

for party, votes in votes_per_party.items():
    votes.sort()
    print( party, votes[-1] )


# In[16]:


## these variables are counted in previous exercises

mean_across_parties = sum_gatherer / len(all_votes)

elected_candidates = 0

for line in open ("elections.txt"):
    line = line.split(",")
    name = line[0]
    party = line[1]
    votes = float( line[2] )
    birth_year = float( line [3] )
    
    if votes >  2 * mean_across_parties:
        elected_candidates = elected_candidates + 1
        
print( elected_candidates )


# In[17]:


mean_across_parties = sum_gatherer / len(all_votes)

elected_candidates_per_party = {}

for line in open ("elections.txt"):
    line = line.split(",")
    name = line[0]
    party = line[1]
    votes = float( line[2] )
    birth_year = float( line [3] )
    
    if votes >  2 * mean_across_parties:
        if party not in elected_candidates_per_party:
            elected_candidates_per_party[ party ] = 0
            
        elected_candidates_per_party[ party ] = elected_candidates_per_party[ party ] + 1
        
print( elected_candidates_per_party )


# In[18]:


## 5.25

words = []
unique_words = 0

for line in open('candidates_tweets.txt'):
    line = line.replace(',', ' ') ## cleaning the data sligtly by removing . and ,
    line = line.replace('.', ' ')
    for word in line.split(' '):
        if word not in words:
            unique_words = unique_words + 1
            words.append( word )

print( unique_words )


# In[19]:


## 5.26

words = {}

for line in open('candidates_tweets.txt'):
    line = line.replace(',', ' ') ## cleaning the data sligtly by removing . and ,
    line = line.replace('.', ' ')
    for word in line.split(' '):
        if word not in words:
            words[ word ] = 0
            
        words[ word ] = words[ word ] + 1

print( words )


# In[20]:


## 5.27

## frequencies of words
frequencies = list( words.values() )
frequencies.sort()
frequencies[-10] ## 10th most highest frequency

for word, frequency in words.items():
    if frequency >= frequencies[-10]:
        print( word, frequency )


# In[21]:


## 5.28

for line in open('candidates_tweets.txt'):
    
    words = {}
    
    line = line.replace(',', ' ') ## cleaning the data sligtly by removing . and ,
    line = line.replace('.', ' ')
    for word in line.split(' '):
        if word not in words:
            words[ word ] = 0
            
        words[ word ] = words[ word ] + 1
        
    print( words )
    
## removed ten most common

most_common_words = ["RT", "a", "for", "to", "the", "of", "and", "that", "in", "is"] ## from exercise 5.27; you could put them on list there

for line in open('candidates_tweets.txt'):
    
    words = {}
    
    line = line.replace(',', ' ') ## cleaning the data sligtly by removing . and ,
    line = line.replace('.', ' ')
    for word in line.split(' '):
        if word not in most_common_words:
            if word not in words:
                words[ word ] = 0

            words[ word ] = words[ word ] + 1
        
    print( words )


# In[22]:


## 5.29

degrees = {}


for line in open ('network.txt'):
    
    node1 = line.split('-')[0].strip()
    if node1 not in degrees:
        degrees[ node1 ] = 0
        
    degrees[ node1 ] = degrees[ node1 ] + 1
    
    node2 = line.split('-')[1].strip()
    if node2 not in degrees:
        degrees[ node2 ] = 0
    
    if node1 != node2: ## for self-directed network, let's not count the network twice
        degrees[ node2 ] = degrees[ node2 ] + 1
    
for node_name , degree_value in degrees.items():
    print ( node_name , 'has a degree of:', degree_value )


# In[23]:


## 5.30

interested_nodes = ['A', 'B', 'C']

for line in open ('network.txt'):
    
    node1 = line.split('-')[0].strip()
    node2 = line.split('-')[1].strip()
    
    if node1 in interested_nodes and node2 in interested_nodes:
        print( node1, node2 )


# In[24]:


## 5.31

edgelist = {}

for line in open ('network.txt'):
    
    node1 = line.split('-')[0].strip()
    node2 = line.split('-')[1].strip()
    
    if node1 not in edgelist:
        edgelist[ node1 ] = []
        
    edgelist[ node1 ].append( node2 )
    
print( edgelist )


# In[25]:


## 5.32

nodes_visited = []
nodes_to_be_visited = ['A']

while len( nodes_to_be_visited ) > 0:
    current_node = nodes_to_be_visited[0]
    nodes_visited.append( current_node )
    connected_nodes = edgelist[ current_node ] ## from exercise 5.31
    for node in connected_nodes:
        if node not in nodes_visited and node not in nodes_to_be_visited:
            nodes_to_be_visited.append( node )
    nodes_to_be_visited.remove( current_node )

print( nodes_visited )


# In[ ]:





# In[ ]:




