#!/usr/bin/env python
# coding: utf-8

# In[1]:


## 7.10

banner_clicks = 0
user001actions = 0

for line in open("user_traces.txt"):
    line = line.strip().split(',')
    
    user = line[0]
    action = line[1]
    
    if user == 'user001':
        user001actions = user001actions + 1
    
    if action == 'click banner':
        banner_clicks = banner_clicks + 1
        
print("User 001 actions", user001actions )
print("Banner clicks", banner_clicks)


# In[4]:


## 7.11

useractions = {}

for line in open("user_traces.txt"):
    line = line.strip().split(',')
    
    user = line[0]
    
    if user not in useractions:
        useractions[ user ] = 0
        
    useractions[ user ] = useractions[ user ] + 1
    
sumofactions = 0
number_of_users = 0

for action_count in useractions.values():
    sumofactions = sumofactions + action_count
    number_of_users = number_of_users + 1
    
print( sumofactions / number_of_users )

highest = 0
highest_name = ''

lowest = 9999
lowest_name = ''

for user, action_count in useractions.items():
    
    if action_count > highest:
        highest = action_count
        highest_name = user
        
    if action_count < lowest:
        lowest = action_count
        lowest_name = user
        
print( highest_name, "had highest number of actions")
print( lowest_name, "had lowest number of actions")


# In[13]:


## 7.12

experimental = {}
experimental['A'] = []
experimental['B'] = []

for line in open('experiment.txt'):
    line = line.strip().split(',')
    condition = line[1]
    
    for i in range(2,6):
        experimental[ condition ].append( float( line[i] ) )
        
## means

sum_of_values = 0
n = 0

for value in experimental['A']:
    sum_of_values = sum_of_values + value
    n = n + 1
    
print("Mean for A", sum_of_values / n )

sum_of_values = 0
n = 0

for value in experimental['B']:
    sum_of_values = sum_of_values + value
    n = n + 1
    
print("Mean for B", sum_of_values / n )


# In[1]:


## 7.13

second_values = []

for line in open('experiment.txt'):
    line = line.strip().split(',')
    second_experimental_value = float( line[3] ) 
    second_values.append( second_experimental_value )
    
sum_of_values = 0
n = 0

for value in second_values:
    sum_of_values = sum_of_values + value
    n = n + 1
    
print("Mean for second values", sum_of_values / n )


# In[ ]:





# In[ ]:




