## 3.12

governor <- 0
win <- 0
president <- 0

data <- read.csv('candidates_tweets.txt', header = FALSE, sep = ' ' )

for( rn in 1:nrow(data) ) {
    line = tolower( data[ rn, 1:ncol(data) ] )
    line = gsub( ',', '', line )  ## removing dots, periods to clean up the data a bit, but this is not extensive
    line = gsub( '\\.', '', line )
    
    for( word in line ) {
        if( word == "governor" ) { ## depending how much is required, this part may look different. now we look for an exact match
            governor <- governor + 1
        }
        
        if( word == "win" ) { ## depending how much is required, this part may look different. now we look for an exact match
            win <- win + 1
        }
        
        if( word == "president" ) { ## depending how much is required, this part may look different. now we look for an exact match
            president <- president + 1
        }
    }
    
}
            
print( paste( governor, win, president ) )

## 3.13

data <- read.csv('candidates_tweets.txt', header = FALSE, sep = ' ' )

for( rn in 1:nrow(data) ) {
    line = tolower( data[ rn, 1:ncol(data) ] )
    line = gsub( ',', '', line )  ## removing dots, periods to clean up the data a bit, but this is not extensive
    line = gsub( '\\.', '', line )
    
    governor <- 0
    win <- 0
    president <- 0
    
    for( word in line ) {
        if( word == "governor" ) { ## depending how much is required, this part may look different. now we look for an exact match
            governor <- governor + 1
        }
        
        if( word == "win" ) { ## depending how much is required, this part may look different. now we look for an exact match
            win <- win + 1
        }
        
        if( word == "president" ) { ## depending how much is required, this part may look different. now we look for an exact match
            president <- president + 1
        }
    }
    
    print( paste( "governor", governor, "times,", "win", win, "times,", "president", president, "times" ) )
    
}

## 3.14

suitable_cases <- 0

data <- read.csv('candidates_tweets.txt', header = FALSE, sep = ' ' )

for( rn in 1:nrow(data) ) {
    line = tolower( data[ rn, 1:ncol(data) ] )
    line = gsub( ',', '', line )  ## removing dots, periods to clean up the data a bit, but this is not extensive
    line = gsub( '\\.', '', line )
    
    governor <- 0
    win <- 0
    president <- 0
    
    for( word in line ) {
        if( word == "governor" ) { ## depending how much is required, this part may look different. now we look for an exact match
            governor <- governor + 1
        }
        
        if( word == "win" ) { ## depending how much is required, this part may look different. now we look for an exact match
            win <- win + 1
        }
        
        if( word == "president" ) { ## depending how much is required, this part may look different. now we look for an exact match
            president <- president + 1
        }
    }
    
    if( governor >= 1 && president >= 1 ) {
        suitable_cases <- suitable_cases + 1
        print( data[ rn, 1:ncol(data) ] )
    }
}
            
        
print( paste("Total of", suitable_cases ) )

## 3.15

candidate_comments <- 0 ## two gatherer variables
other_comments <- 0

data <- read.csv('twitter-conversation.txt', header = FALSE )

for( rn in 1:nrow( data ) ) {
    day <- data[ rn, 1]
    day <- gsub('Day', '', day )
    day <- as.integer( day )
    
    username <- data[rn, 2]

    if( day < 30 ) {
        if( username == 'hansjohansson' || username == 'evapersson' ) {
            candidate_comments <- candidate_comments + 1
        } else {
            other_comments <- other_comments + 1
        }
    } 
}
       
if( candidate_comments > 2 && other_comments > 1 ) {
    print("Discussion qualifies")
}

## 3.16

data <- read.csv('racism-slur.txt', header = FALSE )

for( rn in 1:nrow(data) ) {
    offensive_behaviour <- data[rn, 2]
    white_men <- data[rn, 3]
    friends <- data[rn, 4]
    
    if( offensive_behaviour > 0 ) { ## the person posting the message had a history of o ensive behaviour
        if( white_men == "True" ) { ## its poster was a white man
            if( friends == "False" ) { ## the poster and the target of the racist slur were not friends
                if( grepl("n\\*\\*\\*\\*r", data[rn, 1] ) ) { ## the message contained a racist slur
                    if( grepl("@", data[rn, 1] ) ) { ## the message was a reply to another user
                        print( data[ rn, 1 ])
                    }
                }
            }
        }
    }                     
}




