#!/usr/bin/env python
# coding: utf-8

# In[5]:


## 6.13

## initial values

stockA = 100
stockB = 100

addA = 0.05
removeA = 0.05
addA_dependingB = 0.01

addB = 0.05
removeB = 0.05
addB_dependingA = 0.01

for round in range(1, 51):
    
    stockA = stockA + stockA * addA + stockB * addA_dependingB
    stockA = stockA - stockA * removeA
    
    stockB = stockB + stockB * addB + stockB * addB_dependingA
    stockB = stockB - stockB * removeB
    
print( stockA, stockB )


# In[6]:


## 6.14

## initial values

stockA = 100
stockB = 100

addA = 0.05
removeA = 0.05
addA_dependingB = 0.01

addB = 0.05
removeB = 0.05
addB_dependingA = 0.01

listA = []
listB = []

for round in range(1, 51):
    
    listA.append( stockA )
    listB.append( stockB )
    
    stockA = stockA + stockA * addA + stockB * addA_dependingB
    stockA = stockA - stockA * removeA
    
    stockB = stockB + stockB * addB + stockB * addB_dependingA
    stockB = stockB - stockB * removeB
    
print( listA )
print( listB )


# In[3]:


## 6.15a

agent_red_neighbours = [0, 5, 7, 4]
agent_blue_neighbours = [2, 7, 4, 3]
agent_own_colour = ['blue', 'red', 'blue', 'red']

for colour in agent_own_colour:
    print( colour )


# In[5]:


## 6.15b

agent_red_neighbours = [0, 5, 7, 4]
agent_blue_neighbours = [2, 7, 4, 3]
agent_own_colour = ['blue', 'red', 'blue', 'red']

for index in range( 0, len( agent_own_colour ) ):
    print( agent_own_colour[index], agent_red_neighbours[index], agent_blue_neighbours[index] )


# In[9]:


## 6.15c

agent_red_neighbours = [0, 5, 7, 4]
agent_blue_neighbours = [2, 7, 4, 3]
agent_own_colour = ['blue', 'red', 'blue', 'red']

for index in range( 0, len( agent_own_colour ) ):
    
    neigbours_total = agent_red_neighbours[index] + agent_blue_neighbours[index]
    
    if( agent_own_colour[index] == "red" ):
        if agent_blue_neighbours[index] > neigbours_total / 2:
            print("agent", index, "moves")
    
    if( agent_own_colour[index] == "blue" ):
        if agent_red_neighbours[index] > neigbours_total / 2:
            print("agent", index, "moves")
            
## remember that index starts from 0, so agent 1 is actually the second agent etc


# In[18]:


## 6.16

data = []

for row in open("microsimulation.csv"):
    row = row.strip().split(',')
    
    entry = {}
    
    entry['id'] = float( row[0] )
    entry['sex'] = row[1]
    entry['age'] = float( row[2] )
    entry['number_of_children'] = float( row[3] )
    entry['income'] = float( row[4] )
    entry['tax'] = float( row[5] )
    
    data.append( entry )


# In[22]:


## 6.17

## age bins
agebin = {}
## this a dummy approach for this
agebin['<25'] = 0
agebin['25-49'] = 0
agebin['50-74'] = 0
agebin['>74'] = 0

for entry in data:
    age = entry['age']
    
    if age < 25:
        agebin['<25'] = agebin['<25'] + 1
    if age >= 25 and age < 50:
        agebin['25-49'] = agebin['25-49'] + 1
    if age >= 50 and age < 75:
        agebin['50-74'] = agebin['50-74'] + 1
    if age > 74:
        agebin['>74'] = agebin['>74'] + 1
        
for bin_name, count in agebin.items():
    print( bin_name, '*' * count )


# In[24]:


## 6.18

## simple rule to age people

for year in range(50):
    for entry in data:
        entry['age'] = entry['age'] + 1

## reusing code from prior 6.17
        
## age bins
agebin = {}
## this a dummy approach for this
agebin['<25'] = 0
agebin['25-49'] = 0
agebin['50-74'] = 0
agebin['>74'] = 0

for entry in data:
    age = entry['age']
    
    if age < 25:
        agebin['<25'] = agebin['<25'] + 1
    if age >= 25 and age < 50:
        agebin['25-49'] = agebin['25-49'] + 1
    if age >= 50 and age < 75:
        agebin['50-74'] = agebin['50-74'] + 1
    if age > 74:
        agebin['>74'] = agebin['>74'] + 1
        
for bin_name, count in agebin.items():
    print( bin_name, '*' * count )


# In[ ]:




