## 6.13

## initial values

stockA <- 100
stockB <- 100

addA <- 0.05
removeA <- 0.05
addA_dependingB <- 0.01

addB <- 0.05
removeB <- 0.05
addB_dependingA <- 0.01

for( round in 1:50 ) {
    stockA <- stockA + stockA * addA + stockB * addA_dependingB
    stockA <- stockA - stockA * removeA
    
    stockB <- stockB + stockB * addB + stockB * addB_dependingA
    stockB <- stockB - stockB * removeB
    
}
    
print( stockA )
print( stockB )

## 6.14

## initial values

stockA <- 100
stockB <- 100

addA <- 0.05
removeA <- 0.05
addA_dependingB <- 0.01

addB <- 0.05
removeB <- 0.05
addB_dependingA <- 0.01

listA <- list()
listB <- list()

for( round in 1:50 ) {
    
    listA <- c( listA , stockA )
    listB <- c( listB , stockB )
    
    stockA <- stockA + stockA * addA + stockB * addA_dependingB
    stockA <- stockA - stockA * removeA
    
    stockB <- stockB + stockB * addB + stockB * addB_dependingA
    stockB <- stockB - stockB * removeB

}
    
print( unlist( listA ) )
print( unlist( listB ) )

## 6.15a

agent_red_neighbours <- list( 0, 5, 7, 4 )
agent_blue_neighbours <- list( 2, 7, 4, 3 )
agent_own_colour <- list( 'blue', 'red', 'blue', 'red' )

for( colour in agent_own_colour ) {
    print( colour )
}

## 6.15b

agent_red_neighbours <- list( 0, 5, 7, 4 )
agent_blue_neighbours <- list( 2, 7, 4, 3 )
agent_own_colour <- list( 'blue', 'red', 'blue', 'red' )

for( index in 1:length( agent_own_colour ) ) {
    print( paste( agent_own_colour[[index]], agent_red_neighbours[[index]], agent_blue_neighbours[[index]] ) )
}

## 6.15c

agent_red_neighbours <- list( 0, 5, 7, 4 )
agent_blue_neighbours <- list( 2, 7, 4, 3 )
agent_own_colour <- list( 'blue', 'red', 'blue', 'red' )

for( index in 1:length( agent_own_colour ) ) {
    
    neigbours_total <- agent_red_neighbours[[index]] + agent_blue_neighbours[[index]]
    
    if( agent_own_colour[[index]] == "red" ) {
        if( agent_blue_neighbours[[index]] > neigbours_total / 2 ) {
            print( paste( "agent", index, "moves") )
        }
    }
        
    if( agent_own_colour[[index]] == "blue" ) {
        if( agent_red_neighbours[[index]] > neigbours_total / 2 ) {
            print( paste( "agent", index, "moves") )
        }
    }
}

## 6.16

entries <- list()

data <- read.csv("microsimulation.csv", header = FALSE )

for( rn in 1:nrow(data) ) {
    
    entry = list()
    
    entry[['id']] <- data[ rn, 1 ]
    entry[['sex']] <- data[ rn, 2 ]
    entry[['age']] <- data[ rn, 3 ]
    entry[['number_of_children']] <- data[ rn, 4 ]
    entry[['income']] <- data[rn, 5]
    entry[['tax']] <- data[rn, 6 ]

    entries <- c( entries, list( entry ) ) ## note: the entry is wrapped again as a list to ensure we correctly append not just a flat list with keys
}

print( entries )

## 6.17

## age bins
agebin = list()
## this a dummy approach for this
agebin[['<25']] <- 0
agebin[['25-49']] <- 0
agebin[['50-74']] <- 0
agebin[['>74']] <- 0


for( entry in entries ) {
    age <- entry[['age']]
    if( age < 25 ) {
        agebin[['<25']] <- agebin[['<25']] + 1
    }
    if( age >= 25 & age < 50 ) {
        agebin[['25-49']] <- agebin[['25-49']] + 1
    }
    if( age >= 50 & age < 75 ) {
        agebin[['50-74']] <- agebin[['50-74']] + 1
    }
    if( age > 74 ) {
        agebin[['>74']] <- agebin[['>74']] + 1
    }
}

for( bin_name in names( agebin ) ) {
    count <- agebin[[bin_name]]
    print( paste( bin_name, strrep('*', count ) ) )
}

## 6.18

## simple rule to age people

for(year in 1:50 ) {
    for( row in 1:length(entries) ) {
        entries[[row]][["age"]] <- entries[[row]][["age"]] + 1
    }
}

## reusing code from prior 6.17
        
## age bins
agebin = list()
## this a dummy approach for this
agebin[['<25']] <- 0
agebin[['25-49']] <- 0
agebin[['50-74']] <- 0
agebin[['>74']] <- 0


for( entry in entries ) {
    age <- entry[['age']]
    if( age < 25 ) {
        agebin[['<25']] <- agebin[['<25']] + 1
    }
    if( age >= 25 & age < 50 ) {
        agebin[['25-49']] <- agebin[['25-49']] + 1
    }
    if( age >= 50 & age < 75 ) {
        agebin[['50-74']] <- agebin[['50-74']] + 1
    }
    if( age > 74 ) {
        agebin[['>74']] <- agebin[['>74']] + 1
    }
}

for( bin_name in names( agebin ) ) {
    count <- agebin[[bin_name]]
    print( paste( bin_name, strrep('*', count ) ) )
}


